#include "Fl_RightAlign_Scroll.h"
#include <FL/Fl.H>

/****************************************************************************/

Fl_RightAlign_Scroll::Fl_RightAlign_Scroll(int X, int Y, int W, int H, const char *L)
			: Fl_Scroll(X, Y, W, H, L)
{
}

/****************************************************************************/

Fl_RightAlign_Scroll::~Fl_RightAlign_Scroll()
{
}


/****************************************************************************/

void Fl_RightAlign_Scroll::resize(int X, int Y, int W, int H)
{
	Fl_Scroll::resize(X, Y, W, H);

#ifdef HAVE_STR1895
#warning Compiling with STR1895 patch support
	Fl_Scroll::init_scrollbars();
#endif

	init_align();
}

/****************************************************************************/

void Fl_RightAlign_Scroll::add(Fl_Widget &w)
{
	add(&w);
}

/****************************************************************************/

void Fl_RightAlign_Scroll::add(Fl_Widget *w)
{
	Fl_Scroll::add(w);

#ifdef HAVE_STR1895
#warning Compiling with STR1895 patch support
	Fl_Scroll::init_scrollbars();
#endif

	align_right(w);
}

/****************************************************************************/

void Fl_RightAlign_Scroll::end()
{
	Fl_Scroll::end();

#ifdef HAVE_STR1895
#warning Compiling with STR1895 patch support
	Fl_Scroll::init_scrollbars();
#endif

	init_align();
}
/****************************************************************************/

void Fl_RightAlign_Scroll::init_sizes()
{
	Fl_Scroll::init_sizes();

#ifdef HAVE_STR1895
#warning Compiling with STR1895 patch support
	Fl_Scroll::init_scrollbars();
#endif

	init_align();
}

/****************************************************************************/

void Fl_RightAlign_Scroll::init_align()
{
	// RightAlign align all the children
	for(int i = 0; i < children(); i++)
	{
		Fl_Widget *o = child(i);

		if(o && o != &hscrollbar && o != &scrollbar)
			align_right(o);
	}
}

/****************************************************************************/

void Fl_RightAlign_Scroll::align_right(Fl_Widget *o)
{
	int cx, cy, vw, vh;

	Fl_Scroll::bbox(cx, cy, vw, vh);

	// right horizontally
	if(o->w() < vw)
		cx += vw - o->w();

	o->position(cx, cy);
}

/****************************************************************************/
